#!/usr/bin/python
# -*- coding: UTF-8 -*-

# Copyright 2006 (C) Raster Software Vigo (Sergio Costas)

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import sys
import os
import pygtk # for testing GTK version number
pygtk.require ('2.0')
import gtk
import gtk.glade
import gobject
import subprocess
import signal
import select
import time
import re

title_to_delete=""
chapter_to_delete=""
chapter_to_modify=[]
new_chapter=[]
cancel_prog=False

pathlist=["/usr/bin","/usr/local/bin","/usr/share/bin","/usr/share/local/bin","/bin"]

def launch_program(program,salida=True):

	global pathlist # we try all the possible paths

	print "Launching program:"
	print program
	print

	for elemento in pathlist:
		if elemento[-1]!="/":
			elemento+="/"
		try:
			program2=program[:]
			program2[0]=elemento+program2[0]
			if salida:
				handle=subprocess.Popen(program2,executable=program[0],shell=False,bufsize=32768,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
			else:
				handle=subprocess.Popen(program2,executable=program[0],shell=False,bufsize=32768)
		except OSError:
			pass
		else:
			return handle
	return None

def get_marked():

	global ltitles
	global lchapters
	global structure
	
	try:
		tree,iter=ltitles.get_selection().get_selected()
		titulo=tree.get_value(iter,1)
	except TypeError:
		titulo=""
		
	try:
		tree,iter=lchapters.get_selection().get_selected()
		capitulo=tree.get_value(iter,1)
	except TypeError:
		capitulo=""
	
	return titulo,capitulo

def set_buttons():
	global del_title
	global add_chapter
	global del_chapter
	global prop_chapter
	global main_go
	global structure

	titulo,capitulo=get_marked()
	
	if titulo=="":
		title_marked=False
	else:
		title_marked=True

	if capitulo=="":
		chapter_marked=False
	else:
		chapter_marked=True

	if len(structure)>1:
		del_title.set_sensitive(title_marked)	
	else:
		del_title.set_sensitive(False)
	
	add_chapter.set_sensitive(title_marked)
	del_chapter.set_sensitive(chapter_marked)
	prop_chapter.set_sensitive(chapter_marked)
	
	valor=False
	
	for elemento in structure:
		if len(elemento)>1:
			valor=True
			break
	main_go.set_sensitive(valor)
	set_video_values()

def dvd_changed(args):
	set_video_values()

def set_video_values():

	global structure
	global arbol

	titulo,capitulo=get_marked()

	if capitulo!="":
		for elemento in structure:
			if elemento[0]==titulo:
				encontrado2=elemento
				break
		for elemento in encontrado2:
			if elemento[0]==capitulo:
				encontrado=elemento
				break
		w=arbol.get_widget("o_size")
		w.set_text(str(encontrado[2])+"x"+str(encontrado[3]))
		w=arbol.get_widget("leng")
		w.set_text(str(encontrado[4]))
		w=arbol.get_widget("vrate")
		w.set_text(str(encontrado[8]))
		w=arbol.get_widget("arate")
		w.set_text(str(encontrado[9]))
		w=arbol.get_widget("eleng")
		l=int(((encontrado[8]+encontrado[9])*encontrado[4])/8000)
		w.set_text(str(l))#+(l/50))) # add a 2% for failsafe
		w=arbol.get_widget("achap")
		if encontrado[13]==0:
			w.set_text("no chapters")
		else:
			w.set_text(str(int(encontrado[13])))
	else:
		w=arbol.get_widget("o_size")
		w.set_text("")
		w=arbol.get_widget("leng")
		w.set_text("")
		w=arbol.get_widget("vrate")
		w.set_text("")
		w=arbol.get_widget("arate")
		w.set_text("")
		w=arbol.get_widget("eleng")
		w.set_text("")
		w=arbol.get_widget("achap")
		w.set_text("")
		
	total=0.0
	for elemento in structure:
		if len(elemento)>1:
			for encontrado in elemento[1:]:
				l=float(((encontrado[8]+encontrado[9])*encontrado[4])/8000)
				total+=(l+(l/50))
	w=arbol.get_widget("dvdsize")
	if 0==w.get_active():
		tamano=4500.0
	else:
		tamano=7600.0
	w=arbol.get_widget("usage")
	if total>tamano:
		w.set_fraction(1.0)
	else:
		w.set_fraction(total/tamano)
	w.set_text(str(int((total/tamano)*100))+"%")


def show_about(args):

	global wabout
	
	wabout.show()

def refresh_titles(args=""):

	global arbol
	global list_titles
	global list_chapters
	global structure
	
	list_titles.clear()
	list_chapters.clear()
	
	for elemento in structure:
		entrada=list_titles.insert_before(None,None)
		list_titles.set_value(entrada,1,elemento[0])


def refresh_chapters(args=""):

	global arbol
	global ltitles
	global lchapters
	global structure
	
	titulo,capitulo=get_marked()
	
	if (titulo==""):
		return
	
	list_chapters.clear()
	
	lista=[]
	for elemento in structure:
		if elemento[0]==titulo:
			lista=elemento
			break;
	if lista==[]:
		return
	if len(lista)==1:
		return
		
	for elemento in lista[1:]:
		entrada=list_chapters.insert_before(None,None)
		list_chapters.set_value(entrada,1,elemento[0])
	

def noabort(args):

	global wcancel
	
	wcancel.hide()
	
def siabort(args):

	gtk.main_quit()

def wmain_delete(args,more=""):

	global arbol
	global wcancel
	
	wcancel=arbol.get_widget("wcancel")

	wcancel.show()
	
	return True

def titleclick(args="",more=""):

	global structure
	
	refresh_chapters()
	set_buttons()
	
def chapterclick(args="",more=""):
	set_buttons()

def addtitle(args):

	global structure
	
	tamano=len(structure)
	structure.append(["Title"+str(tamano+1)])
	refresh_titles()
	set_buttons()

def deltitle(args):

	global title_to_delete
	global wdel_title

	titulo,capitulo=get_marked()
	title_to_delete=titulo
	etiqueta=arbol.get_widget("what_title")
	etiqueta.set_text(titulo)
	wdel_title.show()
	
def delete_title(args):

	global title_to_delete
	global wdel_title
	global structure

	contador=1
	tempo=[]
	for elemento in structure:
		if elemento[0]!=title_to_delete:
			elemento[0]="Title"+str(contador)
			tempo.append(elemento)
			contador+=1
	structure=tempo
	refresh_titles()
	set_buttons()
	wdel_title.hide()

def no_delete_title(args):

	global title_to_delete
	global wdel_title

	title_to_delete=""
	wdel_title.hide()

def addchapter(args):

	global wfile
	global chapter_to_modify
	global arbol
	global new_chapter
	global PAL
	
	w=arbol.get_widget("moviefile")
	w.set_filename("")
	w=arbol.get_widget("fileaccept")
	w.set_sensitive(False)
	w=arbol.get_widget("preview_film")
	w.set_sensitive(False)
	w=arbol.get_widget("video_rate")
	w.set_value(4500)
	w=arbol.get_widget("audio_rate")
	w.set_value(224)
	w=arbol.get_widget("do_chapters")
	w.set_active(True)
	w=arbol.get_widget("chapter_long")
	w.set_value(5)
	w=arbol.get_widget("audiodelay")
	w.set_value(0.0)
	if PAL:
		w=arbol.get_widget("video_pal")
	else:
		w=arbol.get_widget("video_ntsc")
	w.set_active(True);
	chapter_to_modify=[]
	new_chapter=[]
	wfile.show()

def chaptercancel(args):

	global wfile
	global arbol
	
	wfile.hide()

def value_changed(args):

	set_final_size()
	refresh_film_data()

def filechanged(filechoser):
	
	global new_chapter
	global arbol
	
	fileaccept=arbol.get_widget("fileaccept")
	preview_film2=arbol.get_widget("preview_film")
		
	filename=filechoser.get_filename()
	if (filename==None) or (filename==""):
		fileaccept.set_sensitive(False)
		preview_film2.set_sensitive(False)
		return

	handler=subprocess.Popen('mplayer -identify -ao null -vo null -frames 0 "'+filename+'" 2>/dev/null |grep ID',shell=True,bufsize=32768,stdout=subprocess.PIPE)
	handler.wait()
	vrate=0
	arate=0
	width=0
	heigh=0
	fps=0
	length=0
	audio=0
	video=0
	while True:
		linea=handler.stdout.readline()
		if linea=="":
			break
		if linea[:16]=="ID_VIDEO_BITRATE":
			vrate=int(linea[17:])
		if linea[:14]=="ID_VIDEO_WIDTH":
			width=int(linea[15:])
		if linea[:15]=="ID_VIDEO_HEIGHT":
			heigh=int(linea[16:])
		if linea[:12]=="ID_VIDEO_FPS":
			posic=linea.find(".")
			if posic==-1:
				fps=int(linea[13:])
			else:
				fps=int(linea[13:posic])
				if linea[posic+1]=="9":
					fps+=1
		if linea[:16]=="ID_AUDIO_BITRATE":
			arate=int(linea[17:])
			
		if linea[:13]=="ID_AUDIO_RATE":
			audiorate=int(linea[14:])
			
		if linea[:9]=="ID_LENGTH":
			length=int(float(linea[10:]))
		if linea[:11]=="ID_VIDEO_ID":
			video+=1
		if linea[:11]=="ID_AUDIO_ID":
			audio+=1
	error=False
	if video==0:
		if audio==0:
			show_error("File doesn't seem to be a video file.")
			error=True
		else:
			show_error("File seems to be an audio file.")
			error=True
	#elif (fps!=25) and (fps!=30) and (fps!=24):
	#	show_error("The FPS are different than 24, 25 and 30\n(Value: "+str(fps)+").")
	#	error=True
	
	if error:
		new_chapter=[]
		fileaccept.set_sensitive(False)
		preview_film2.set_sensitive(False)
		return
	
	fileaccept.set_sensitive(True)
	preview_film2.set_sensitive(True)
	
	while filename[-1]=="/":
		filename=filename[:-1]
	
	nombre=filename
	while True: # get the filename without the path
		posic=nombre.find("/")
		if posic==-1:
			break
		else:
			nombre=nombre[posic+1:]
	# filename, path, width, heigh, length (seconds), original fps, original vrate, original arate,
	# final vrate, final arate, final width, final heigh, 0=Black bars, chapters length, audio delay,
	# final fps, original audio rate (uncompressed)
	new_chapter=[nombre, filename, width,heigh, length, fps, vrate/1000, arate/1000, 0, 0, 720, 576, 0 , 0 ,0 ,25 ,audiorate]
	set_final_size()
	refresh_film_data()

def set_final_size():

	global arbol
	global new_chapter
	global PAL
	
	w=arbol.get_widget("video_pal")
	if w.get_active():
		PAL=True
		nheigh1=576
		nheigh2=288
	else:
		PAL=False
		nheigh1=480
		nheigh2=240
		
	if len(new_chapter)==0:
		return
	
	if PAL:
		new_chapter[15]=25
	else:
		new_chapter[15]=30
	
	if (new_chapter[2]<=352) and (new_chapter[3]<=nheigh2):
		new_chapter[10]=352
		new_chapter[11]=nheigh2
	else:
		new_chapter[10]=720
		new_chapter[11]=nheigh1

def refresh_film_data():
	global arbol
	global new_chapter
	
	if len(new_chapter)==0:
		empty=True
	else:
		empty=False
	
	w=arbol.get_widget("o_size2")
	if empty:
		w.set_text("")
	else:
		w.set_text(str(new_chapter[2])+"x"+str(new_chapter[3]))
	w=arbol.get_widget("leng2")
	if empty:
		w.set_text("")
	else:
		w.set_text(str(new_chapter[4]))
	w=arbol.get_widget("fps")
	if empty:
		w.set_text("")
	else:
		w.set_text(str(new_chapter[5]))
	w=arbol.get_widget("vrate2")
	if empty:
		w.set_text("")
	else:
		w.set_text(str(new_chapter[6]))
	w=arbol.get_widget("arate2")
	if empty:
		w.set_text("")
	else:
		w.set_text(str(new_chapter[7]))
	w=arbol.get_widget("video_rate")
	vrate=w.get_value()
	w=arbol.get_widget("audio_rate")
	arate=w.get_value()
	w=arbol.get_widget("eleng2")
	if empty:
		w.set_text("")
	else:
		l=int(((vrate+arate)*new_chapter[4])/8000)
		w.set_text(str(l))#+(l/50))) # add a 2% for failsafe
		
	w=arbol.get_widget("f_size2")
	if empty:
		w.set_text("")
	else:
		w.set_text(str(new_chapter[10])+"x"+str(new_chapter[11]))

def show_error(message):

	global arbol
	global werror
	
	label=arbol.get_widget("l_error")
	label.set_text(message)
	werror.show()

def errorok(args):

	global werror
	
	werror.hide()

def global_delete(arg1,arg2):
#just hide that widget

	arg1.hide()
	return True

def set_file_values():

	global arbol
	global new_chapter

	w=arbol.get_widget("blackbars")
	if w.get_active():
		new_chapter[12]=0
	else:
		new_chapter[12]=1
	
	w=arbol.get_widget("do_chapters")
	if w.get_active():
		w=arbol.get_widget("chapter_long")
		new_chapter[13]=w.get_value()
	else:
		new_chapter[13]=0
	
	w=arbol.get_widget("audiodelay")
	new_chapter[14]=float(w.get_value())
		
	w=arbol.get_widget("video_rate")
	new_chapter[8]=int(w.get_value())
	w=arbol.get_widget("audio_rate")
	new_chapter[9]=int(w.get_value())
	
	w=arbol.get_widget("video_pal")
	if w.get_active():
		new_chapter[15]=25
	else:
		new_chapter[15]=30

def add_a_file(args):

	global arbol
	global new_chapter
	global structure
	global wfile
	global chapter_to_modify
	
	set_file_values()
	
	titulo,capitulo=get_marked()
	
	if len(chapter_to_modify)==0:
	
		for elemento in structure:
			if elemento[0]==titulo:
				elemento.append(new_chapter)
				break
	else:
		for elemento in range(len(new_chapter)):
			chapter_to_modify[elemento]=new_chapter[elemento]
	
	save_config()
	
	wfile.hide()
	refresh_chapters()
	set_buttons()

def delete_chapter(args):

	global wdel_chapter
	global arbol
	
	titulo,capitulo=get_marked()
	label=arbol.get_widget("labelchapter")
	label.set_text(capitulo)
	
	wdel_chapter.show()

def delete_chapter_no(args):

	global wdel_chapter

	wdel_chapter.hide()
	
def delete_chapter_yes(args):

	global arbol
	global structure
	global wdel_chapter
	
	wdel_chapter.hide()
	
	newstruct=[]
	newtitle=[]

	titulo,capitulo=get_marked()

	for elemento in structure:
		if elemento[0]!=titulo:
			newstruct.append(elemento)
		else:
			for elemento2 in elemento:
				if elemento2[0]!=capitulo:
					newtitle.append(elemento2)
			newstruct.append(newtitle)
	structure=newstruct
	
	refresh_chapters()
	set_buttons()

def modify_chapter(args):

	global arbol
	global wfile
	global structure
	global chapter_to_modify
	
	titulo,capitulo=get_marked()
	
	felemento=[]
	for elemento in structure:
		if elemento[0]==titulo:
			felemento=elemento
			break
	
	for elemento in felemento:
		if elemento[0]==capitulo:
			chapter_to_modify=elemento
		
	filechoser=arbol.get_widget("moviefile")
	filechoser.set_filename(chapter_to_modify[1])
	fileaccept=arbol.get_widget("fileaccept")
	fileaccept.set_sensitive(True)
	preview_film2=arbol.get_widget("preview_film")
	preview_film2.set_sensitive(True)
	vrate=arbol.get_widget("video_rate")
	vrate.set_value(chapter_to_modify[8])
	arate=arbol.get_widget("audio_rate")
	arate.set_value(chapter_to_modify[9])
	w=arbol.get_widget("audiodelay")
	w.set_value(chapter_to_modify[14])
	if chapter_to_modify[12]==0:
		w=arbol.get_widget("blackbars")
		w.set_active(True)
	else:
		w=arbol.get_widget("scalepict")
		w.set_active(True)
		
	w=arbol.get_widget("do_chapters")
	if chapter_to_modify[13]==0:
		w.set_active(False)
		w=arbol.get_widget("chapter_long")
		w.set_sensitive(False)
	else:
		w.set_active(True)
		w=arbol.get_widget("chapter_long")
		w.set_sensitive(True)
		w.set_value(chapter_to_modify[13])
		
	if chapter_to_modify[15]==25:
		w=arbol.get_widget("video_pal")
	else:
		w=arbol.get_widget("video_ntsc")
	w.set_active(True)
		
	refresh_film_data()
	new_chapter=[]
	wfile.show()

def chapter_changed(args):

	global arbol
	
	w=arbol.get_widget("chapter_long")
	w.set_sensitive(args.get_active())

def empty_no(args):

	global wempty_titles
	
	wempty_titles.hide()

def empty_yes(args):

	global wempty_titles
	
	wempty_titles.hide()
	create_dvd2()

def create_dvd(args):

	global structure
	
	vacio=False
	for elemento in structure:
		if len(elemento)<2:
			vacio=True
			break
	
	if vacio:
		wempty_titles.show()
	else:
		create_dvd2()

def cancel_progress(args):

	global cancel_prog
	
	cancel_prog=True

def folder_return(args):

	global arbol

	wfolder=arbol.get_widget("wfolder")
	wfolder.hide()

def create_dvd2():

	global arbol
	global wfolder
	
	w=arbol.get_widget("directorio_final")
	w.set_filename("")
	w.set_current_folder("")
	w=arbol.get_widget("iso_name")
	w.set_text("movie")
	

	iso_changed("")
	wfolder.show()
	
def iso_changed(args):

	global arbol
	
	iso_name=arbol.get_widget("iso_name")
	iso_folder=arbol.get_widget("directorio_final")
	
	w=arbol.get_widget("folder_accept")
	
	mode=True
	
	if iso_name.get_text()=="":
		mode=False
		
	folder=iso_folder.get_filename()
	if folder==None:
		mode=False
	elif folder=="":
		mode=False
		
	w.set_sensitive(mode)
	
def convert_file(afile,filefolder,filename,cfiles,titles,files,total,seconds=0):

	global cancel_prog
	global arbol
	
	ppartial=arbol.get_widget("progresspartial")
	ptotal=arbol.get_widget("progress_total")
	label=arbol.get_widget("lcreating")

	counter=0

	if cancel_prog:
		return True
	addbars=False
	framerate=int(afile[5])
	videorate=int(afile[8])
	audiorate=int(afile[9])
	audio_final_rate=int(afile[16])
	audiodelay=float(afile[14])
	final_framerate=float(afile[15])
	max_videorate=int(videorate*1.5)
	if max_videorate>8500:
		max_videorate=8500
	resx_final=afile[10]
	resy_final=afile[11]
	resx_original=afile[2]
	resy_original=afile[3]
	
	if afile[12]==0: # check if has to add black bars
		if (resx_original*3)!=(resy_original*4): # aspect ratio must be 4:3
			addbars=True
			if (resx_original%2)==1:
				resx_original+=1
			if (resy_original%2)==1:
				resy_original+=1
			if (resx_original*3)>(resy_original*4): # have to add bars at up and down
				resx_inter=resx_original
				resy_inter=int((resx_original*3)/4)
				if (resy_inter%2)==1:
					resy_inter+=1
				addx=0
				addy=int((resy_inter-resy_original)/2)
			else: # have to add bars at left and rigth
				resy_inter=resy_original
				resx_inter=int((resy_original*4)/3)
				if (resx_inter%2)==1:
					resx_inter+=1
				addy=0
				addx=int((resx_inter-resx_original)/2)
				addbars=False # due to a bug in MENCODER, we don't put theses bars
	
	if addbars==False:
		resx_inter=resx_original
		resy_inter=resy_original

	command_var=["mencoder"]
	if audio_final_rate!=48000:
		command_var.append("-srate")
		command_var.append("48000")
		command_var.append("-af")
		command_var.append("lavcresample=48000")
	command_var.append("-oac")
	command_var.append("lavc")
	command_var.append("-ovc")
	command_var.append("lavc")
	command_var.append("-of")
	command_var.append("mpeg")
	command_var.append("-mpegopts")
	command_var.append("format=dvd")
	
	if seconds!=0:
		command_var.append("-endpos")
		command_var.append(str(seconds))
	if audiodelay!=0.0:
		command_var.append("-delay")
		command_var.append(str(audiodelay))
	command_var.append("-ofps")
	if final_framerate==30:
		command_var.append("30000/1001")
	else:
		command_var.append(str(int(final_framerate)))
	command_var.append("-vf")
	lineatemp=""
	if addbars and ((resx_inter!=resx_original) or (resy_inter!=resy_original)):
		lineatemp+="expand="+str(resx_inter)+":"+str(resy_inter)+":"+str(addx)+":"+str(addy)+","

	if (resx_inter!=resx_final) or (resy_inter!=resy_final):
		lineatemp+="scale="+str(resx_final)+":"+str(resy_final)+","
	lineatemp+="harddup"
	command_var.append(lineatemp)
	command_var.append("-lavcopts")
	command_var.append("vcodec=mpeg2video:vrc_maxrate="+str(max_videorate)+":vrc_buf_size=1835:vbitrate="+str(videorate)+":keyint=15:acodec=ac3:abitrate="+str(audiorate)+":aspect=4/3")
	
	currentfile=filefolder+filename+"_"
	if titles<10:
		currentfile+="0"
	currentfile+=str(titles)+"_"
	if files<10:
		currentfile+="0"
	currentfile+=str(files)+'.mpg'
	
	command_var.append("-o")
	command_var.append(currentfile)
	command_var.append(afile[1])
	
	handler=launch_program(command_var)
	percent2=120
	refresh=False
	
	busqueda=re.compile("Pos:[0-9 ]*\.[0-9]s")
	if seconds==0:
		divide=float(afile[4])
		ppartial.show()
	else:
		divide=float(seconds)
		ppartial.hide()
	while True:
		v1,v2,v3=select.select([handler.stdout,handler.stderr],[],[])
		for elem in v1:
			if elem==handler.stderr:
				temporal=handler.stderr.readline(80)
				print temporal,
			else:
				linea=handler.stdout.readline(80)
				if linea=="":
					break
				if cancel_prog:
					break
				if linea[-1]=="\n":
					print linea,
					break
				pos=linea.find("Pos:")
				if pos==-1:
					break
				while(pos+10)>len(linea):
					linea+=handler.stdout.read(2)
				elemento=busqueda.findall(linea)
				if len(elemento)==0:
					break
				counter+=1
#				pos=linea.find("(")
#				if pos!=-1:
#					while (pos+4)>len(linea):
#						linea+=handler.stdout.read(2)
#					counter+=1
				valuetemp=float(elemento[0][4:-1])
				value=(100*valuetemp)/divide
				refresh=False
				if (value!=percent2) or (percent2==120):
					percent1=((100*cfiles)/total)+(value/total)
					ptotal.set_fraction(percent1/100)
					ptotal.set_text(str(int(percent1))+"%")
					if seconds==0:
						label.set_text("Converting files from title "+str(titles)+"\n"+afile[0])
					else:
						label.set_text("Creating preview\n"+afile[0])
					ppartial.set_fraction(value/100)
					percent2=value
					ppartial.set_text(str(int(percent2))+"%")
					refresh=True
		if (linea=="") or cancel_prog:
			break
		if linea[-1]=="\n":
			continue
		if counter==20:
			refresh=True
		if refresh:
			refresh_screen()
			counter=0
	if cancel_prog:
		os.kill(handler.pid,signal.SIGKILL)
	handler.wait()
	retcode=handler.returncode
	if (retcode!=0) or cancel_prog:
		p=subprocess.Popen('rm "'+currentfile+'"',shell=True,bufsize=32768)
		p.wait()
		if not cancel_prog:
			cause=1
		cancel_prog=True
		return True
	else:
		return False


def create_dvd3(args):

	global wmain
	global arbol
	global structure
	global cancel_prog
	global wprogress
	global returnmain
	
	wmain.hide()
	
	cancel_prog=False
	
	w=arbol.get_widget("wfolder")
	w.hide()
	
	os.nice(1) # less priority to allow to use the computer without speed penalty while compressing
	
	w=arbol.get_widget("iso_name")
	filename=w.get_text()
	w=arbol.get_widget("directorio_final")
	filefolder=w.get_filename()
	
	if filefolder[-1]!="/":
		filefolder+="/"
	
	cancel_prog=False
	
	ppartial=arbol.get_widget("progresspartial")
	ptotal=arbol.get_widget("progress_total")
	label=arbol.get_widget("lcreating")
	
	actions=0
	
	w=arbol.get_widget("only_convert")
	if w.get_active():
		actions=1
	else:
		w=arbol.get_widget("create_dvd")
		if w.get_active():
			actions=2
		else:
			actions=3
	
	wprogress.show()
	refresh_screen()
	refresh_screen()
	total=0
	
	for elemento in structure:
		total+=((len(elemento))-1)
	total+=2
	
	try:
		fichero=open(filefolder+filename+".xml","w")
		fichero.write('<dvdauthor dest="'+filefolder+filename+'">\n')
		fichero.write("<vmgm> </vmgm>\n<titleset>\n<titles>\n")
		titles=0
		for elemento in structure:
			titles+=1
			fichero.write("<pgc>\n")
			if len(elemento)>1:
				files=0
				for elemento2 in elemento[1:]:
					files+=1
					currentfile=filefolder+filename+"_"
					if titles<10:
						currentfile+="0"
					currentfile+=str(titles)+"_"
					if files<10:
						currentfile+="0"
					currentfile+=str(files)+'.mpg'
					fichero.write('<vob file="'+currentfile+'" ')
					if elemento2[13]!=0: # add chapters
						minutes=0
						curr_second=0
						hours=0
						fichero.write('chapters="')
						toadd=int(elemento2[13])
						while curr_second<elemento2[4]:
							if (minutes==0) and (hours==0):
								fichero.write("0")
							else:
								fichero.write(",")
								if hours!=0:
									if hours<10:
										fichero.write("0")
									fichero.write(str(hours)+":")
								if minutes<10:
									fichero.write("0")
								fichero.write(str(minutes)+":00")
							minutes+=toadd
							if minutes>59:
								minutes-=60
								hours+=1
							curr_second+=(60*toadd)
						fichero.write('" ')
					fichero.write('/>\n')
				fichero.write("</pgc>\n")
		fichero.write("</titles>\n</titleset>\n</dvdauthor>")
		fichero.close()
	except IOError:
		wprogress.hide()
		w=arbol.get_widget("error2_label")
		w.set_text("Failed to write to the destination directory.\nCheck that you have privileges and free space there.")
		w=arbol.get_widget("werror2")
		returnmain=w			
		w.show()			
		return
	
	resx_inter=0
	resy_inter=0
	addx=0
	addy=0
	titles=0
	cfiles=0.0
	percent1=0
	counter=0
	cause=0
	
	for title in structure:
		if cancel_prog:
			break
		titles+=1
		if len(title)>1:
			files=0
			for afile in title[1:]:
				files+=1
				if False==convert_file(afile,filefolder,filename,cfiles,titles,files,total):
					cfiles+=1.0
				else:
					break
				
					
	if cancel_prog:
		wprogress.hide()
		if cause==0:
			w=arbol.get_widget("w_aborted")
			returnmain=w
			w.show()
			return
		if cause==1:
			w=arbol.get_widget("error2_label")
			if percent2==120: # still hadn't take a value, so it seems it failed (core dump)
				w.set_text("Conversion failed.\nIt seems a bug of Mencoder.")
			else:
				w.set_text("Conversion failed\nMaybe you ran out of disk space?")
			w=arbol.get_widget("werror2")
			returnmain=w			
			w.show()			
			return


	if actions>1:
		label.set_text("Creating DVD tree structure")
		total2=0
		total_films=total-1
		percent1=float((100*(total-2))/total)
		ptotal.set_fraction(percent1/100)
		ptotal.set_text(str(int(percent1))+"%")
		ppartial.set_fraction(0)
		ppartial.set_text("0%")
		handler=launch_program(["dvdauthor","-x",filefolder+filename+".xml"])
		refresh_screen()
		while True:
			v1,v2,v3=select.select([handler.stdout,handler.stderr],[],[])
			for elem in v1:
				temporal=elem.readline(80)
				if temporal=="":
					break
				if len(temporal)>10:
					if temporal[0:11]=="INFO: Video":
						total2+=1
						percent2=float((100*total2)/total_films)
						percent1=float((100*(total-2))/total)+(percent2/total)
						ptotal.set_fraction(percent1/100)
						ptotal.set_text(str(int(percent1))+"%")
						ppartial.set_fraction(percent2/100)
						ppartial.set_text(str(int(percent2))+"%")
			refresh_screen()
			if (temporal=="") or (cancel_prog):
				break
		cause=0
		if cancel_prog:
			os.kill(handler.pid,signal.SIGKILL)
		handler.wait()
		retcode=handler.returncode
		if retcode!=0:
			cause=1
		if cancel_prog:
			wprogress.hide()
			if cause==0:
				w=arbol.get_widget("w_aborted")
				returnmain=w
				w.show()
				return
			if cause==1:
				w=arbol.get_widget("error2_label")
				w.set_text("Failed to create the DVD tree\nMaybe you ran out of disk space")
				w=arbol.get_widget("werror2")
				returnmain=w				
				w.show()			
				return
		handle=subprocess.Popen("rm "+filefolder+filename+"_??_??.mpg",bufsize=8192,shell=True)
		
			
	if actions>2:
		label.set_text("Creating ISO file")
		percent1=float((100*(total-1))/total)
		ptotal.set_fraction(percent1/100)
		ptotal.set_text(str(int(percent1))+"%")
		ppartial.set_fraction(0)
		ppartial.set_text("0%")
		handler=launch_program(["mkisofs","-dvd-video","-v","-o",filefolder+filename+".iso",filefolder+filename])
		refresh_screen()
		while True:
			v1,v2,v3=select.select([handler.stdout,handler.stderr],[],[])
			for elem in v1:
				temporal=elem.readline(80)
				if temporal=="":
					break
				punto=temporal.find("done, estimate")
				if (punto!=-1) and (temporal[2].isdigit()) and ((temporal[1].isdigit()) or (temporal[1]==" ")):
					percent2=float(temporal[1:3])
					percent1=float(((100*(total-1))/total)+(percent2/total))
					ptotal.set_fraction(percent1/100)
					ptotal.set_text(str(int(percent1))+"%")
					ppartial.set_fraction(percent2/100)
					ppartial.set_text(str(int(percent2))+"%")
			refresh_screen()
			if (temporal=="") or (cancel_prog):
				break
		cause=0
		if cancel_prog:
			os.kill(handler.pid,signal.SIGKILL)
		handler.wait()
		retcode=handler.returncode
		if retcode!=0:
			cause=1
		if cancel_prog:
			wprogress.hide()
			if cause==0:
				w=arbol.get_widget("w_aborted")
				returnmain=w
				w.show()
				return
			if cause==1:
				w=arbol.get_widget("error2_label")
				w.set_text("Failed to create the ISO image\nMaybe you ran out of disk space")
				w=arbol.get_widget("werror2")
				returnmain=w				
				w.show()			
				return
		handle=subprocess.Popen("rm -rf "+filefolder+filename,bufsize=8192,shell=True)
			
			

	wprogress.hide()
	w=arbol.get_widget("w_end")
	w.show()

def return_main(args):

	global returnmain
	
	if returnmain!=None:
		returnmain.hide()
		
	wmain.show()

def refresh_screen():
	
	while gtk.events_pending():
		gtk.main_iteration()

def exit_program(args):

	gtk.main_quit()

def alwaystrue(args="",arg2=""):

	return True

def check_program(programa):
	
	p=subprocess.Popen(programa+" >/dev/null 2>/dev/null",shell=True)
	p.wait()
	return p.returncode
	

def init_main():

	global wmain
	global returnmain
	global arbol
	global ltitles
	global lchapters
	global del_title
	global add_chapter
	global del_chapter
	global prop_chapter
	global main_go
	global wdel_title
	global wfile
	global wabout
	global werror
	global wdel_chapter
	global wempty_titles
	global wprogress
	global wfolder
	global wprograms
	global wpreview
	global wreplay
	
	returnmain=None
	
	w=arbol.get_widget("directorio_final")
	w.connect("selection-changed",iso_changed)
	
	wfolder=arbol.get_widget("wfolder")
	wfolder.connect("delete_event",global_delete)
	
	wprogress=arbol.get_widget("wprogress")
	wprogress.connect("delete_event",alwaystrue)
	
	wabout=arbol.get_widget("aboutdialog1")
	wabout.connect("delete_event",global_delete)
	
	wmain=arbol.get_widget("wmain")
	wmain.connect("delete_event",wmain_delete)
	
	w=arbol.get_widget("main_cancel")
	w.connect("clicked",wmain_delete)
	
	w=arbol.get_widget("about")
	w.connect("clicked",show_about)
	
	w=arbol.get_widget("prog_cancel")
	w.connect("clicked",cancel_progress)
	
	ltitles=arbol.get_widget("ltitles")
	lchapters=arbol.get_widget("lchapters")
	
	ltitles.set_model(list_titles)
	lchapters.set_model(list_chapters)
	
	renderertitles=gtk.CellRendererText()
	columntitles = gtk.TreeViewColumn("Title", renderertitles, text=1)
	ltitles.append_column(columntitles)
	
	rendererchapters=gtk.CellRendererText()
	columnchapters = gtk.TreeViewColumn("Title", rendererchapters, text=1)
	lchapters.append_column(columnchapters)
	
	ltitles.connect("button_release_event",titleclick)
	lchapters.connect("button_release_event",chapterclick)
	
	add_title=arbol.get_widget("add_title")
	add_title.connect("clicked",addtitle)
	del_title=arbol.get_widget("del_title")
	del_title.connect("clicked",deltitle)
	add_chapter=arbol.get_widget("add_chapter")
	add_chapter.connect("clicked",addchapter)
	del_chapter=arbol.get_widget("del_chapter")
	del_chapter.connect("clicked",delete_chapter)
	prop_chapter=arbol.get_widget("prop_chapter")
	prop_chapter.connect("clicked",modify_chapter)
	main_go=arbol.get_widget("main_go")
	main_go.connect("clicked",create_dvd)
	
	w=arbol.get_widget("create_iso")
	w.set_active(True)
	
	wdel_title=arbol.get_widget("wdel_title")
	wdel_title.connect("delete_event",global_delete)
	w=arbol.get_widget("deltitle_yes")
	w.connect("clicked",delete_title)
	w=arbol.get_widget("deltitle_no")
	w.connect("clicked",no_delete_title)
	
	wdel_chapter=arbol.get_widget("wdel_chapter")
	wdel_chapter.connect("delete_event",global_delete)
	w=arbol.get_widget("delchapter_yes")
	w.connect("clicked",delete_chapter_yes)
	w=arbol.get_widget("delchapter_no")
	w.connect("clicked",delete_chapter_no)
	
	wempty_titles=arbol.get_widget("wempty_titles")
	wempty_titles.connect("delete_event",global_delete)
	w=arbol.get_widget("empty_yes")
	w.connect("clicked",empty_yes)
	w=arbol.get_widget("empty_no")
	w.connect("clicked",empty_no)
	
	w=arbol.get_widget("dvdsize")
	w.set_active(0)
	w.connect("changed",dvd_changed)
	
	wfile=arbol.get_widget("wfile")
	wfile.connect("delete_event",global_delete)
	w=arbol.get_widget("filecancel")
	w.connect("clicked",chaptercancel)
	w=arbol.get_widget("moviefile")
	w.connect("selection-changed",filechanged)
	
	werror=arbol.get_widget("werror")
	werror.connect("delete_event",global_delete)
	w=arbol.get_widget("error_ok")
	w.connect("clicked",errorok)
	
	w=arbol.get_widget("video_rate")
	w.connect("value_changed",value_changed)
	w=arbol.get_widget("audio_rate")
	w.connect("value_changed",value_changed)
	w=arbol.get_widget("video_pal")
	w.connect("toggled",value_changed)
	
	w=arbol.get_widget("fileaccept")
	w.connect("clicked",add_a_file)
	
	w=arbol.get_widget("do_chapters")
	w.connect("clicked",chapter_changed)
	
	w=arbol.get_widget("msgno")
	w.connect("clicked",noabort)
	w=arbol.get_widget("msgyes")
	w.connect("clicked",siabort)
	
	w=arbol.get_widget("folder_cancel")
	w.connect("clicked",folder_return)
	w=arbol.get_widget("folder_accept")
	w.connect("clicked",create_dvd3)
	w=arbol.get_widget("iso_name")
	w.connect("changed",iso_changed)
	
	w=arbol.get_widget("button_aborted")
	w.connect("clicked",return_main)
	w=arbol.get_widget("w_aborted")
	w.connect("delete_event",alwaystrue)
	w=arbol.get_widget("error2_button")
	w.connect("clicked",return_main)
	w=arbol.get_widget("werror2")
	w.connect("delete_event",alwaystrue)
	w=arbol.get_widget("end_button")
	w.connect("clicked",exit_program)
	w=arbol.get_widget("w_end")
	w.connect("delete_event",alwaystrue)
	
	wpreview=arbol.get_widget("wpreview")
	wpreview.connect("delete_event",global_delete)
	
	wprograms=arbol.get_widget("wprograms")
	wprograms.connect("delete_event",alwaystrue)
	w=arbol.get_widget("program_exit")
	w.connect("clicked",exit_program)
	
	w=arbol.get_widget("preview_film")
	w.connect("clicked",preview_film)
	w=arbol.get_widget("preview_cancel")
	w.connect("clicked",preview_cancel)
	w=arbol.get_widget("preview_ok")
	w.connect("clicked",preview_ok)
	
	wreplay=arbol.get_widget("wreplay")
	wreplay.connect("delete_event",global_delete)
	
	w=arbol.get_widget("replay_yes")
	w.connect("clicked",play_preview)
	
	w=arbol.get_widget("replay_no")
	w.connect("clicked",noreplay)
	
	refresh_titles()
	set_buttons()
	
	wmain.show()

def noreplay(args):

	global wreplay
	
	wreplay.hide()
	launch_program(["rm", "/var/tmp/movietemp_01_01.mpg"],False)

def preview_film(args):

	global wpreview
	global arbol
		
	w=arbol.get_widget("seconds_preview")
	w.set_value(60)
	wpreview.show()

def preview_cancel(args):

	global wpreview
	
	wpreview.hide()

def preview_ok(args):

	global wpreview
	global arbol
	global wprogress
	global cancel_prog
	global wreplay
	
	set_file_values()
	wpreview.hide()
	w=arbol.get_widget("seconds_preview")
	wprogress.show()
	cancel_prog=False
	retorno=convert_file(new_chapter,"/var/tmp/","movietemp",0.0,1,1,1,w.get_value())
	wprogress.hide()
	if retorno==False:
		play_preview("")
	
def play_preview(args):

	global wreplay
	
	wreplay.hide()
	parameters=["mplayer","/var/tmp/movietemp_01_01.mpg"]
	salida=launch_program(parameters,False)
	salida.wait()
	wreplay.show()

def load_config():

	global PAL
	
	PAL=True
	
	home=os.environ.get("HOME")
	if home[-1]!="/":
		home+="/"
	home+=".devede"
	try:
		archivo=open(home,"r")
		linea=archivo.readline()
		if linea=="ntsc\n":
			PAL=False
		archivo.close()
	except IOError:
		PAL=True
	

def save_config():

	global PAL
	
	home=os.environ.get("HOME")
	if home[-1]!="/":
		home+="/"
	home+=".devede"
	try:	
		archivo=open(home,"w")
		if PAL:
			archivo.write("pal\n")
		else:
			archivo.write("ntsc\n")
		archivo.close()
	except IOError:
		pass

list_titles=gtk.TreeStore(gobject.TYPE_PYOBJECT,gobject.TYPE_STRING)
list_chapters=gtk.TreeStore(gobject.TYPE_PYOBJECT,gobject.TYPE_STRING)

structure=[["Title1"]]

load_config()

home=os.environ.get("HOME")
if home[-1]!="/":
	home+="/"

try:
	arbol=gtk.glade.XML("/usr/share/devede/devede.glade")
except RuntimeError:
	arbol=gtk.glade.XML("devede.glade")

init_main()

errors=""
if 127==check_program("mplayer -v"):
	errors+="mplayer\n"
if 127==check_program("mencoder -msglevel help"):
	errors+="mencoder\n"
if 127==check_program("dvdauthor --help"):
	errors+="dvdauthor\n"
if 127==check_program("mkisofs -help"):
	errors+="mkisofs\n"

if errors!="":
	w=arbol.get_widget("programs_label")
	w.set_text(errors)
	wprograms.show()

gtk.main()
